"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}var createResizeDetector=_interopDefault(require("element-resize-detector")),React=require("react"),React__default=_interopDefault(React),PropTypes=_interopDefault(require("prop-types")),ReactDOM=_interopDefault(require("react-dom")),invariant=_interopDefault(require("invariant")),throttle=_interopDefault(require("lodash.throttle")),debounce=_interopDefault(require("lodash.debounce")),instances={};function resizeDetector(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:"scroll";return instances[e]||(instances[e]=createResizeDetector({strategy:e})),instances[e]}var classCallCheck=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},createClass=function(){function o(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}return function(e,t,r){return t&&o(e.prototype,t),r&&o(e,r),e}}(),_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var o in r)Object.prototype.hasOwnProperty.call(r,o)&&(e[o]=r[o])}return e},inherits=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)},objectWithoutProperties=function(e,t){var r={};for(var o in e)0<=t.indexOf(o)||Object.prototype.hasOwnProperty.call(e,o)&&(r[o]=e[o]);return r},possibleConstructorReturn=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},defaultConfig={monitorWidth:!0,monitorHeight:!1,monitorPosition:!1,refreshRate:16,refreshMode:"throttle",noPlaceholder:!1,resizeDetectorStrategy:"scroll"};function getDisplayName(e){return e.displayName||e.name||"Component"}var ReferenceWrapper=function(e){function t(){return classCallCheck(this,t),possibleConstructorReturn(this,(t.__proto__||Object.getPrototypeOf(t)).apply(this,arguments))}return inherits(t,e),createClass(t,[{key:"render",value:function(){return React.Children.only(this.props.children)}}]),t}(React.Component);function Placeholder(e){var t=e.className,r=e.style,o={};return t||r?(t&&(o.className=t),r&&(o.style=r)):o.style={width:"100%",height:"100%"},React__default.createElement("div",o)}ReferenceWrapper.displayName="SizeMeReferenceWrapper",ReferenceWrapper.propTypes={children:PropTypes.element.isRequired},Placeholder.displayName="SizeMePlaceholder",Placeholder.propTypes={className:PropTypes.string,style:PropTypes.object};var renderWrapper=function(u){function e(e){var t=e.explicitRef,r=e.className,o=e.style,n=e.size,i=e.disablePlaceholder,a=(e.onSize,objectWithoutProperties(e,["explicitRef","className","style","size","disablePlaceholder","onSize"])),l=(null==n||null==n.width&&null==n.height&&null==n.position)&&!i,s={className:r,style:o};null!=n&&(s.size=n);var c=l?React__default.createElement(Placeholder,{className:r,style:o}):React__default.createElement(u,_extends({},s,a));return React__default.createElement(ReferenceWrapper,{ref:t},c)}return e.displayName="SizeMeRenderer("+getDisplayName(u)+")",e.propTypes={explicitRef:PropTypes.func.isRequired,className:PropTypes.string,style:PropTypes.object,size:PropTypes.shape({width:PropTypes.number,height:PropTypes.number}),disablePlaceholder:PropTypes.bool,onSize:PropTypes.func},e};function sizeMe(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:defaultConfig,t=e.monitorWidth,u=void 0===t?defaultConfig.monitorWidth:t,r=e.monitorHeight,h=void 0===r?defaultConfig.monitorHeight:r,o=e.monitorPosition,p=void 0===o?defaultConfig.monitorPosition:o,n=e.refreshRate,a=void 0===n?defaultConfig.refreshRate:n,i=e.refreshMode,l=void 0===i?defaultConfig.refreshMode:i,s=e.noPlaceholder,c=void 0===s?defaultConfig.noPlaceholder:s,d=e.resizeDetectorStrategy,f=void 0===d?defaultConfig.resizeDetectorStrategy:d;invariant(u||h||p,'You have to monitor at least one of the width, height, or position when using "sizeMe"'),invariant(16<=a,"It is highly recommended that you don't put your refreshRate lower than 16 as this may cause layout thrashing."),invariant("throttle"===l||"debounce"===l,'The refreshMode should have a value of "throttle" or "debounce"');var y="throttle"===l?throttle:debounce;return function(e){var r=renderWrapper(e),t=function(e){function i(){var e,t,c;classCallCheck(this,i);for(var r=arguments.length,o=Array(r),n=0;n<r;n++)o[n]=arguments[n];return(t=c=possibleConstructorReturn(this,(e=i.__proto__||Object.getPrototypeOf(i)).call.apply(e,[this].concat(o)))).state={width:void 0,height:void 0,position:void 0},c.determineStrategy=function(e){e.onSize?(c.callbackState||(c.callbackState=_extends({},c.state)),c.strategy="callback"):c.strategy="render"},c.strategisedSetState=function(e){"callback"===c.strategy&&(c.callbackState=e,c.props.onSize(e)),c.setState(e)},c.strategisedGetState=function(){return"callback"===c.strategy?c.callbackState:c.state},c.refCallback=function(e){c.element=e},c.hasSizeChanged=function(e,t){var r=e,o=t,n=r.position||{},i=o.position||{};return h&&r.height!==o.height||p&&(n.top!==i.top||n.left!==i.left||n.bottom!==i.bottom||n.right!==i.right)||u&&r.width!==o.width},c.checkIfSizeChanged=y(function(e){var t=e.getBoundingClientRect(),r=t.width,o=t.height,n=t.right,i=t.left,a=t.top,l=t.bottom,s={width:u?r:null,height:h?o:null,position:p?{right:n,left:i,top:a,bottom:l}:null};c.hasSizeChanged(c.strategisedGetState(),s)&&c.strategisedSetState(s)},a),possibleConstructorReturn(c,t)}return inherits(i,e),createClass(i,[{key:"componentDidMount",value:function(){this.detector=resizeDetector(f),this.determineStrategy(this.props),this.handleDOMNode(!0)}},{key:"componentWillReceiveProps",value:function(e){this.determineStrategy(e)}},{key:"componentDidUpdate",value:function(){this.handleDOMNode()}},{key:"componentWillUnmount",value:function(){this.hasSizeChanged=function(){},this.checkIfSizeChanged=function(){},this.domEl&&(this.detector.uninstall(this.domEl),this.domEl=null)}},{key:"handleDOMNode",value:function(e){var t=this.element&&ReactDOM.findDOMNode(this.element);t?(!e&&this.domEl&&this.detector.removeAllListeners(this.domEl),this.domEl=t,this.detector.listenTo(this.domEl,this.checkIfSizeChanged)):!e&&this.domEl&&(this.detector.removeAllListeners(this.domEl),this.domEl=null)}},{key:"render",value:function(){var e=sizeMe.enableSSRBehaviour||sizeMe.noPlaceholders||c||"callback"===this.strategy,t=_extends({},this.state);return React__default.createElement(r,_extends({explicitRef:this.refCallback,size:"callback"===this.strategy?null:t,disablePlaceholder:e},this.props))}}]),i}(React__default.Component);return t.displayName="SizeMe("+getDisplayName(e)+")",t.propTypes={onSize:PropTypes.func},t.WrappedComponent=e,t}}sizeMe.enableSSRBehaviour=!1,sizeMe.noPlaceholders=!1,module.exports=sizeMe;
//# sourceMappingURL=react-sizeme.min.js.map
